#ifndef PARSER_HPP
#define PARSER_HPP

#include <list>
#include <string>
#include "data.hpp"

#define YYSTYPE void*

#define YYLTYPE location

#define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).start   = YYRHSLOC(Rhs, 1).start;                   \
          (Current).end  = YYRHSLOC(Rhs, N).end;                        \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).start  = YYRHSLOC(Rhs, 0).start;                     \
          (Current).end  = YYRHSLOC(Rhs, 0).end;                         \
        } \
    while (0)


namespace parser {

    // Parameter to the parser.
    // users of this module must assign their own their own
    // input function to get_char()
    // Instead of returing the next character this may return > 256, and
    // assign a number to *p (thus the return value is infact inside p)
    // retrun_val-256 is number of char read to compute number.
	extern int (*get_char)(int* p);

    extern int error_loc;
	extern std::list<function>* program;
	extern bool yyparse(std::list<function>* pgm);
}

#endif
